.SUFFIXES: .asm

ARCH    =arm

CFLAGS	=-g -Os -fno-builtin -ffreestanding -nostdinc -pipe -mcpu=arm926ej-s -mabi=apcs-gnu -nostdlib -nostartfiles -nodefaultlibs -fno-strict-aliasing -fno-common -ffixed-r8 -msoft-float
# defines
MAKEFILE=Makefile
MAKEDEP=$(MAKEFILE)
INCDIR	=../../include/
CCASM	=$(CC) -D__ASSEMBLY__ -g -Os -pipe -mcpu=arm926ej-s -mabi=apcs-gnu -fno-strict-aliasing  -fno-common -ffixed-r8 -msoft-float -fno-builtin -ffreestanding -nostdinc
CCA	=$(CC) $(CFLAGS) -I$(INCDIR) -I../../build/main
OBJS	=int.o fault.o handler.o task.o arch.o timer.o rtc.o smp.o elf.o ctx.o io.o
# Select ARM Board
BOARDS	=bd/intcp.o bd/verpb.o

ifneq ($(V),1)
	Q := @
endif

# targets
all: $(OBJS) $(BOARDS) arch.a

clean:
	$(Q)rm -f *.o ../arch.a boot/start.o  $(OBJS) $(BOARDS)
	@printf "  CLEAN\n";

# implicit rules
.S.o:
	@printf " ASM  $(subst $(shell pwd)/,,$(@))\n";
	$(Q)$(CCASM) -c -o$@ $<

.c.o:
	@printf "  CC  $(subst $(shell pwd)/,,$(@))\n";
	$(Q)$(CCA) -c -o$@ $<

# explicit rules
arch.a:	$(OBJS) $(BOARDS) $(MAKEDEP)
	@printf "  AR  $(subst $(shell pwd)/,,$(@))\n";
	$(Q)$(AR) rcs ../arch.a $(OBJS) $(BOARDS)